﻿using System;
using System.Collections.Generic;

namespace ProjectAtelier.Entities;

public class Order
{
    public int Id { get; private set; }
    public DateTime DataTime { get; private set; }
    public OrderStatus Status { get; private set; }
    public string Characteristic { get; private set; } = string.Empty;
    public IEnumerable<OrderProduct> OrderProduct { get; private set; } = [];
    public int IdClient { get; private set; }

    public static Order CreateOperation(int id, OrderStatus status, string characteristic, IEnumerable<OrderProduct> orderProduct, int idClient, DateTime dateTime)
    {
        return new Order
        {
            Id = id,
            DataTime = dateTime,
            Status = status,
            Characteristic = characteristic,
            OrderProduct = orderProduct,
            IdClient = idClient
        };
    }
}